SystemOrganization addCategory: #'CS520-HomeAutomation'!

RectangleMorph subclass: #DeviceView
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!DeviceView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:20'!
createFromDevice: aDevice
	| newDeviceView |
	newDeviceView := DeviceView new.
	newDeviceView setDevice: aDevice.
	^ newDeviceView.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:21'!
setDevice: aDevice 
	device := aDevice.
	self updateViewFromModel.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:18'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: device name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:18'!
setViewProperties
	self width: device width.
	self height: device height.
	self color: device color.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:16'!
updateViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	"room devices do: [ :each | self addMorphBack: (DeviceView createFromDevice: each) ]."
	! !

RectangleMorph subclass: #RoomView
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:09'!
createFromRoom: aRoom
	| newRoomView |
	newRoomView := RoomView new.
	newRoomView setRoom: aRoom.
	^ newRoomView.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:13'!
installDevices
	| currPosition hGap vGap |
	hGap := 5.
	vGap := 5.
	currPosition := hGap @ vGap.
	room attachedDevices
		do: [ :each | 
			| newDeviceView |
			self width > (currPosition x + each width + hGap)
				ifTrue: [ 
					newDeviceView := DeviceView createFromDevice: each.
					newDeviceView position: currPosition.
					self addMorphFront: newDeviceView.
					currPosition := currPosition + ((newDeviceView width + hGap) @ 0) ] ]! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: room name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:22'!
setRoom: aRoom
	room := aRoom.
	self updateViewFromModel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setViewProperties
	self width: room width.
	self height: room height.
	self color: room color.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:55'!
updateViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	self installDevices.! !

TestCase subclass: #HomeAutomationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 19:48'!
setUp! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testAttachDeviceToRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test' withColor: Color black.
	device := Camera new.
	device attachTo: room.
	
	self assert: (room hasDevice: device).
	self assert: (device isAttachedTo: room).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:20'!
testCreateCameraSensor
	| camera |
	camera := Camera createWithName: 'Camera 01'.
	self assert: (camera name = 'Camera 01').
	self assert: (camera size = (30@30)).
	self assert: (camera color = Color black).
	self assert: (camera height = 30).
	self assert: (camera width = 30).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testCreateRoom
	| room |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	self assert: (room name = 'Kitchen').
	self assert: (room width = 50).
	self assert: (room height = 100).
	self assert: (room center = (25@50)).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
testUserEntersRoom
	| room user |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (room includesUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:09'!
testUserEntersRoomWithDevice
	| room device user mockListener |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockListener := MockListener new.
	mockListener observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (mockListener detectedUser: user).! !

Object subclass: #HomeAutomationDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #HomeAutomationObserver
	instanceVariableNames: 'usersObserved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:22'!
detectedUser: aUser 
	^ usersObserved includes: aUser.	
! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:22'!
initialize
	super initialize.
	usersObserved := Set new.
! !

!HomeAutomationObserver methodsFor: 'associating' stamp: 'CameronRieck 3/6/2013 20:30'!
observe: aDevice
	aDevice when: #userEnters send: #userEntered: to: self with: #aUser.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:27'!
userEntered: aUser
	usersObserved add: aUser.! !

HomeAutomationObserver subclass: #MockListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #HomeAutomationSensor
	instanceVariableNames: 'name size color room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationSensor subclass: #Camera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Camera class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:02'!
createWithName: aName
	| newCamera |
	newCamera := Camera new.
	newCamera name: aName.
	^ newCamera.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:02'!
initialize
	self size: 30@30.
	self color: Color black.! !

!HomeAutomationSensor methodsFor: 'associating' stamp: 'CameronRieck 3/4/2013 20:56'!
attachTo: aRoom
	room := aRoom.
	aRoom addDevice: self.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color
	^ color! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color: aColor
	color := aColor.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
height
	^ size y! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 21:02'!
initialize
	name := ''.
	size := 0@0.
	color := Color white.
	room := nil.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 20:55'!
isAttachedTo: aRoom 
	^ aRoom hasDevice: self! !

!HomeAutomationSensor methodsFor: 'associating' stamp: 'CameronRieck 3/4/2013 21:00'!
isAttachedToARoom
	^ room notNil! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:26'!
name 
	^ name! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:25'!
name: aByteString 
	name := aByteString.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size
	^ size! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size: aSize
	size := aSize.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
width
	^ size x! !

Object subclass: #Room
	instanceVariableNames: 'roomSize attachedDevices color name usersPresent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:48'!
createWithSize: aPoint 
	| room |
	room := Room new.
	room setSize: aPoint.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:53'!
createWithSize: aPoint withName: aName
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:07'!
createWithSize: aPoint withName: aName withColor: aColor
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	room setColor: aColor.
	^ room.! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/2/2013 15:41'!
addDevice: aDevice
	attachedDevices add: aDevice.! !

!Room methodsFor: 'updating' stamp: 'CameronRieck 3/6/2013 20:34'!
addUser: aUser 
	usersPresent add: aUser.
	attachedDevices do: [ :each | each triggerEvent: #userEnters with: aUser ].! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
attachedDevices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
center
	^ ((self width) / 2)@((self height) / 2)! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
color
	^ color! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
devices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:48'!
hasDevice: aDevice
	^ attachedDevices includes: aDevice! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 12:14'!
height
	^ roomSize y! !

!Room methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:02'!
includesUser: aUser 
	^ usersPresent includes: aUser.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
initialize
	attachedDevices := OrderedCollection new.
	usersPresent := Set new.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
length
	^ roomSize y! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
name
	^ name! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
setColor: aColor
	color := aColor.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
setName: aName
	name := aName.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/2/2013 15:35'!
setSize: aPoint 
	roomSize := aPoint.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
width
	^ roomSize x! !

Object subclass: #User
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/6/2013 19:59'!
createWithName: aName 
	| newUser |
	newUser := User new.
	newUser name: aName.
	^ newUser.! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:00'!
name: aName 
	name := aName.! !
